import com.sun.tools.jdi.EventSetImpl;

import java.io.Serializable;
import java.lang.reflect.Array;
import java.util.*;

public class MyArrayList <T> implements Iterable<T>{

    private static final int DEFAULT_INITIAL_CAPACITY = 10;
    private T[] array;
    private int size;

    public MyArrayList() {
        array = (T[]) new Object[DEFAULT_INITIAL_CAPACITY];
        size = 0;
    }
    public MyArrayList(int initialCapacity) {
        array = (T[]) new Object[initialCapacity];
        size = 0;
    }

    public boolean add(T element) {
        array = checkAndIncreaseCapacity(array);
        array[size] = element;
        size++;
        return true;
    }

    private T[] checkAndIncreaseCapacity(T[] array) {
        if (size >= array.length) {
            array = (T[]) Array.newInstance(this.array.getClass().getComponentType(), (array.length * 3) / 2 + 1);
        }
        return array;
    }

    private boolean rangeCheck(int index) {
        if (index >= size || index < 0) {
            throw new IndexOutOfBoundsException();
        }
        return true;
    }

    public boolean add(T element, int index) {
        rangeCheck(index);
        array = checkAndIncreaseCapacity(array);
        size++;
        T[] temp = Arrays.copyOf(array, array.length);
        for (int i = 0; i < size; i++) {
            if (i < index) {
                temp[i] = array[i];
            }
            else if (i == index) {
                temp[i] = element;
            }
            else {
                temp[i] = array[i -1];
            }
        }
        array = temp;
        return true;
    }

    public void set(T element, int index) {
        rangeCheck(index);
        array[index] = element;
    }

    public T get(int index) {
        rangeCheck(index);
        return array[index];
    }

    public T remove(int index) {
        rangeCheck(index);
        array[index] = null;
        size--;
        T[] temp = (T[]) new Object[array.length];
        for (int i = 0; i < size; i++) {
            if (i < index) {
                temp[i] = array[i];
            }
            else {
                temp[i] = array[i+1];
            }
        }
        array = temp;
        return null;
    }


    public Object[] toArray() {
        return Arrays.copyOf(this.array, size);
    }

    public<T> T[] toArray(T[] a) {
        for (int i = 0; i < size; i++) {
            a[i] = (T) this.array[i];
        }
        return a;
    }

    public void clear() {
        array = (T[]) new Object[DEFAULT_INITIAL_CAPACITY];
        size = 0;
    }

    public boolean isEmpty() {
        if (size == 0) return true;
        else return false;
    }
    public boolean contains(Object element) {
        if (indexOf(element) >= 0) return true;
        else return false;
    }
    public int indexOf(Object element) {
        int index = -1;
        for (int i = 0; i < size; i++) {
            if (array[i] == element) {
                index = i;
                break;
            }
        }
        return index;
    }
    public void addAll(Collection<? extends T> c) {
        for (T t : c) {
            add(t);
        }
    }
    public void trimToSize() {
        array = (T[]) Array.newInstance(this.array.getClass().getComponentType(), size);
    }
    public int size() {
        return size;
    }
    public int capactiy() {
        return array.length;
    }

    @Override
    public Iterator<T> iterator() {
        return new MyArrayListIterator();
    }
    private class MyArrayListIterator<T> implements Iterator<T> {
        private int currIndex;

        private MyArrayListIterator() {
            this.currIndex = 0;
        }

        public boolean hasNext() {
            return currIndex < size;
        }
        public T next() {
            if (! this.hasNext())
                throw new IllegalStateException();
            T currValue = (T) array[currIndex];
            currIndex ++;
            return currValue;
        }

        public void remove() {
            MyArrayList.this.remove(currIndex);
        }

    }
}


