import javax.swing.text.html.HTMLDocument;
import java.util.Collection;
import java.util.Iterator;
import java.util.Set;

public class MySet <T> implements Set<T> {

    private MyArrayList<T> arrayList;

    public MySet() {
        arrayList = new MyArrayList<T>();
    }
    public MySet(int size) {
        arrayList = new MyArrayList<T>(size);
    }

    @Override
    public boolean add(T t) {
        if (!arrayList.contains(t)) {
            arrayList.add(t);
            return true;
        }
        else return false;
    }
    @Override
    public boolean addAll(Collection<? extends T> c) {
        Iterator iterator = c.iterator();
        int addedCount = 0;

        while(iterator.hasNext()) {
            T element = (T) iterator.next();
            if (!arrayList.contains(element)) {
                arrayList.add(element);
                addedCount++;
            }
        }
        if (addedCount > 0) return true;
        else return false;
    }

    @Override
    public boolean remove(Object o) {
        int index = arrayList.indexOf(o);
        if (index == -1) {
            return false;
        }
        arrayList.remove(index);
        return true;
    }

    @Override
    public boolean removeAll(Collection<?> c) {
        Iterator iterator = c.iterator();
        boolean removedAnyElements = false;

        while (iterator.hasNext()) {
            boolean removedThisElement = remove(iterator.next());
            if (removedThisElement) {
                removedAnyElements = true;
            }
        }
        if (removedAnyElements) return true;
        else return false;
    }

    @Override
    public boolean retainAll(Collection<?> c) {
        for (Object o : arrayList) {
            if (!c.contains(o)) {
                //arrayList.remove();
            }
        }


        return false;
    }

    @Override
    public boolean isEmpty() {
        if (size() == 0) return true;
        else return false;
    }

    public void clear() {
        arrayList.clear();
    }

    @Override
    public boolean contains(Object o) {
        if (arrayList.contains(o)) {
            return true;
        }
        else return false;
    }

    @Override
    public boolean containsAll(Collection<?> c) {
        for (Object o : c) {
            if (!arrayList.contains(o)) return false;
        }
        return true;
    }
    @Override
    public int size() {
        return arrayList.size();
    }

    @Override
    public boolean equals(Object o) {
        try {
            MySet compareSet = (MySet) o;

            if (compareSet.size() != arrayList.size()) {
                return false;
            }

            Iterator<T> compareIterator = compareSet.iterator();
            Iterator<T> thisIterator = iterator();

            while (compareIterator.hasNext() && thisIterator.hasNext()) {
                if (!(compareIterator.next().equals(thisIterator.next()))) {
                    return false;
                }
            }
        }
        catch (ClassCastException e){
            return false;
        }
        return true;
    }

    @Override
    public Object[] toArray() {
        return arrayList.toArray();
    }

    @Override
    public <T> T[] toArray(T[] a) {
        return arrayList.toArray(a);
    }

    @Override
    public Iterator<T> iterator() {
        return new MySetIterator();
    }


    private class MySetIterator<T> implements Iterator<T> {
        private int currIndex;

        private MySetIterator() {
            this.currIndex = 0;
        }

        public boolean hasNext() {
            return currIndex < arrayList.size();
        }
        public T next() {
            if (! this.hasNext())
                throw new IllegalStateException();
            T currValue = (T) arrayList.get(currIndex);
            currIndex ++;
            return currValue;
        }

        public void remove() {
            arrayList.remove(currIndex);
        }

    }
}
