import org.junit.Assert;
import org.junit.Test;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Map;
import java.util.Set;

import static org.junit.Assert.*;

public class MyMapTest {

    @Test
    public void testContains() {
        MyMap<String, Integer> myMap = new MyMap<String,Integer>();
        myMap.put("Targaryen", 13);
        Assert.assertTrue(myMap.containsKey("Targaryen"));
    }
    @Test
    public void testContains2() {
        MyMap<String, Integer> myMap = new MyMap<String,Integer>();
        myMap.put("Targaryen", 13);
        Assert.assertFalse(myMap.containsKey("Snow"));
    }
    @Test
    public void testClear() {
        MyMap<String, Integer> myMap = new MyMap<String,Integer>();
        myMap.put("Targaryen", 13);
        myMap.clear();
        Assert.assertFalse(myMap.containsKey("Targaryen"));
    }
    @Test
    public void testContainsValue() {
        MyMap<String, Integer> myMap = new MyMap<String,Integer>();
        myMap.put("Targaryen", 13);
        Assert.assertTrue(myMap.containsValue(13));
    }
    @Test
    public void testContainsValue2() {
        MyMap<String, Integer> myMap = new MyMap<String,Integer>();
        myMap.put("Targaryen", 13);
        Assert.assertFalse(myMap.containsValue(11));
    }
    @Test
    public void testGet() {
        MyMap<String, Integer> myMap = new MyMap<String,Integer>();
        myMap.put("Targaryen", 13);
        Integer expected = 13;
        Integer actual = myMap.get("Targaryen");
        Assert.assertEquals(expected, actual);
    }
    @Test
    public void testSize() {
        MyMap<String, Integer> myMap = new MyMap<String,Integer>();
        myMap.put("Targaryen", 13);
        myMap.put("Stark", 19);
        myMap.put("Lannister", 2);
        int expected = 3;
        int actual = myMap.size();
        Assert.assertEquals(expected, actual);
    }
    @Test
    public void testIsEmpty() {
        MyMap<String, Integer> myMap = new MyMap<String,Integer>();
        assertTrue(myMap.isEmpty());
    }
    @Test
    public void testKeySet() {
        Set<String> expected = new MySet<String>();
        expected.add("Targaryen");
        expected.add("Stark");
        expected.add("Lannister");

        MyMap<String, Integer> myMap = new MyMap<String,Integer>();
        myMap.put("Targaryen", 13);
        myMap.put("Stark", 19);
        myMap.put("Lannister", 2);

        Set<String> actual = myMap.keySet();
        Assert.assertEquals(expected, actual);
    }
    @Test
    public void testPutAll() {
        Map<String, Integer> toAdd = new MyMap<>();
        toAdd.put("Targaryen", 13);
        toAdd.put("Stark", 19);
        toAdd.put("Lannister", 2);

        MyMap<String, Integer> myMap = new MyMap<>();
        myMap.putAll(toAdd);

        Set<String> expected = new MySet<String>();
        expected.add("Targaryen");
        expected.add("Stark");
        expected.add("Lannister");

        Set<String> actual = myMap.keySet();
        Assert.assertEquals(expected, actual);
    }
    @Test
    public void testRemove() {
        Map<String, Integer> toAdd = new MyMap<>();
        toAdd.put("Targaryen", 13);
        toAdd.put("Stark", 19);
        toAdd.put("Lannister", 2);

        MyMap<String, Integer> myMap = new MyMap<>();
        myMap.putAll(toAdd);
        myMap.remove("Stark");

        Assert.assertFalse(myMap.containsKey("Stark"));
    }
    @Test
    public void testGetValues() {
        Map<String, Integer> toAdd = new MyMap<>();
        toAdd.put("Targaryen", 13);
        toAdd.put("Stark", 19);
        toAdd.put("Lannister", 2);

        MyMap<String, Integer> myMap = new MyMap<>();
        myMap.putAll(toAdd);

        Collection<Integer> expected = new ArrayList<>();
        expected.add(13);
        expected.add(19);
        expected.add(2);

        Collection<Integer> actual = myMap.values();

        Assert.assertEquals(expected, actual);
    }

}